#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <fcntl.h>

#include <stdio.h>
#include <stdlib.h>

#include <sys/wait.h>

#define checkError(expr,userMsg) \
    do { \
        if (!(expr)) { \
            perror(userMsg);\
            exit(EXIT_FAILURE); \
        } \
    } while (0)

int main(int argc, char** argv) {

    printf("Parent strated\n");

    pid_t childPid = fork();
    checkError(childPid != -1, "fork");

    if (childPid != 0) {
        // parent process
        printf("Parent: my pid %d, child id %d\n",
                getpid(), childPid);
    }
    else {
        // child process
        printf("Child: my pid %d, parent id %d\n",
            getpid(), getppid());

        exit(EXIT_SUCCESS);
    }

    // oba procesa
    //printf("Oba procesa\n");
    int status = 0;
    checkError(wait(&status) != -1, "wait");

    printf("Parent je sacekao child proces\n");

    exit(EXIT_SUCCESS);
}